
/* ====================================================
 * An attempt to reconcile Numeric and numarray
 *
 * This is version v0.1
 *
 * Dominique Orban                  Michael Friedlander
 * All rights reserved                Chicago, May 2003
 * ====================================================
 */

/*
 * Numeric is used by default, until numarray prevails.
 * To use numarray, use  -DUSE_NUMARRAY when compiling.
 */

#ifdef USE_NUMPY /* -------------------------------- */

#include "numpy/arrayobject.h"       /* NumPy header */
#define tInt32    NPY_INT
#define tLong     NPY_LONG
#define tFloat64  NPY_DOUBLE

#else               /* ----------------------------- */

#include "Numeric/arrayobject.h"   /* Numeric header */
#define tInt32    PyArray_INT
#define tLong     PyArray_LONG
#define tFloat64  PyArray_DOUBLE

#define NA_OFFSETDATA(p) ((void *)(((char*)(p)->data)))

#endif              /* ----------------------------- */
